module HaskellType where
import ParseLib
import List ( intersperse )

data HaskellType = HVariable String
                 | HConstructor String [HaskellType]
                 | HTypeConstructor String
                 | HList HaskellType
                 | HFunction HaskellType HaskellType
                 | HTupel [HaskellType]
                 | HData HaskellType [HaskellType]
                 | HTypeApplication HaskellType HaskellType
                 deriving Eq
-- onderdeel g

instance Show HaskellType where
  show (HVariable name) = name
  show (HConstructor name xs) = name ++ " " ++ (unwords $ map show xs)
  show (HTypeConstructor name) = name
  show (HList list) = sBrackets $ show list
  show (HFunction arg1 arg2) = sParens (show arg1 ++ "->" ++ show arg2)
  show (HTupel list) = sCommaList $ map show list
  show (HData constr constrs) = "data " ++ show constr ++ " = " ++ (unwords $ intersperse ("\n  | ") $ map show constrs) ++ "\n"
  show (HTypeApplication arg1 arg2) = sParens(show arg1 ++ " " ++ show arg2)
       -- todo: hier staan nu nog (eigenlijk) te veel haakjes

surround open close s = open ++ s ++ close
sParens = surround "(" ")"
sBrackets = surround "[" "]"
sCommaList = sParens . concat . intersperse ","
