import GenFold
import HaskellType
import Parser
import Lexer
import ParseLib
import System

main = do args <- getArgs
          let (Load readfile, Write writefile) = parseParameters $ args
          xs <- readFile readfile
          putStrLn $ "Succesfully read from " ++ readfile
          let datas = printHaskellTypes (show) $ start parseInvoer $ start lexicalScanner xs
          let folds = printHaskellTypes genFold $ start parseInvoer $ start lexicalScanner xs
          writeFile writefile (datas ++ "\n" ++ folds)
          putStrLn $ "Datas succesfully parsed, and written with folds to " ++ writefile
          return ()

printHaskellTypes :: (HaskellType -> String) -> [HaskellType] -> String
printHaskellTypes f xs = foldr (\x -> ((f x)++)) "" xs

start :: Eq a => Parser a b -> [a] -> b
start p s = fst $ head $ filter (null . snd) (p s)

parseParameters :: [String] -> (Command, Command)
parseParameters = start parseCommands

data Command = Load String
             | Write String
             deriving Show

parseCommands :: Parser String (Command, Command)
parseCommands = sort <$> many parseCommand where
  sort xs = (setLoad $ filter isLoad xs, setWrite $ filter isWrite xs)
  setLoad [] = Load "voorbeeld.hs"
  setLoad xs = head xs
  setWrite [] = Write "result.hs"
  setWrite xs = head xs
  isLoad (Load _) = True
  isLoad _        = False
  isWrite (Write _) = True
  isWrite _         = False

parseCommand :: Parser String Command
parseCommand =   (\_ f -> Load f) <$> symbol "--input" <*> satisfy (\_ -> True)
             <|> (\_ f -> Write f) <$> symbol "--output" <*> satisfy (\_ -> True)